local _, class = UnitClass("player")
if ( class ~= "DEATHKNIGHT" ) then
	return
end

local name, table = ...
table.ria = table.ria or CreateFrame("Frame", "RIAFrame", UIParent)
local ria = table.ria

local CURRENT_MAX_RUNES = 0
local MAX_RUNE_CAPACITY = 7
local path = "Interface\\AddOns\\RuneItAll\\images\\"
local r = {}
local o = {}
local t = {}
local b = {}
local events = {}
local cdText = {}
local hide = true
local runica = false

local runeColors = {
	["BLOOD"]  = {1,   0,   0},
	["UNHOLY"] = {0,   0.5, 0},
	["FROST"]  = {0,   1,   1},
	["DEATH"]  = {0.8, 0.1, 1}
}

local iconTextures = {
	["BLOOD"] = {
		["BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood.blp",
		["BETA"] = path.."beta\\blood.blp",
		["DKI"] = path.."DKI\\blood.tga",
		["LETTER"] = path.."letter\\blood.tga",
		["ORB"] = path.."orb\\blood.tga",
		["ENHANCED"] = path.."beta-enhanced\\blood.tga",
		["JAPANESE"] = path.."japanese\\blood.tga",
		["RUNICA"] = path.."runica\\blood.tga",
		["NEW_BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring.blp"
	},
	["DEATH"] = {
		["BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death.blp",
		["BETA"] = path.."beta\\death.blp",
		["DKI"] = path.."DKI\\death.tga",
		["LETTER"] = path.."letter\\death.tga",
		["ORB"] = path.."orb\\death.tga",
		["ENHANCED"] = path.."beta-enhanced\\death.tga",
		["JAPANESE"] = path.."japanese\\death.tga",
		["RUNICA"] = path.."runica\\death.tga",
		["NEW_BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring.blp"
	},
	["UNHOLY"] = {
		["BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy.blp",
		["BETA"] = path.."beta\\unholy.blp",
		["DKI"] = path.."DKI\\unholy.tga",
		["LETTER"] = path.."letter\\unholy.tga",
		["ORB"] = path.."orb\\unholy.tga",
		["ENHANCED"] = path.."beta-enhanced\\unholy.tga",
		["JAPANESE"] = path.."japanese\\unholy.tga",
		["RUNICA"] = path.."runica\\unholy.tga",
		["NEW_BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring.blp"
	},
	["FROST"] = {
		["BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost.blp",
		["BETA"] = path.."beta\\frost.blp",
		["DKI"] = path.."DKI\\frost.tga",
		["LETTER"] = path.."letter\\frost.tga",
		["ORB"] = path.."orb\\frost.tga",
		["ENHANCED"] = path.."beta-enhanced\\frost.tga",
		["JAPANESE"] = path.."japanese\\frost.tga",
		["RUNICA"] = path.."runica\\frost.tga",
		["NEW_BLIZZARD"] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring.blp"
	}
}

function CreateRuneButtonIndividualFrames()
	for i=1,MAX_RUNE_CAPACITY do
		r[i] = CreateFrame("Button", "RBI"..i, ria)
		r[i]:SetSize(18, 18)

		if i == 1 then
			r[i]:SetPoint("LEFT", ria, "LEFT")
		else
			r[i]:SetPoint("LEFT", r[i-1], "RIGHT", 3, 0)
		end

		t[i] = r[i]:CreateTexture(r[i]:GetName().."Border", "OVERLAY")
		t[i]:SetSize(24, 24)
		t[i]:SetPoint("CENTER", r[i], "CENTER", 0, -1)
		--t[i]:SetTexture(iconTexture[riaDb.runeType][riaDb.textureChoice])
		-- t[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring.blp")
		-- t[i]:SetVertexColor(0.6,0.6,0.6,1)

		b[i] = r[i]:CreateTexture(r[i]:GetName().."Rune", "ARTWORK")
		b[i]:SetSize(24, 24)
		b[i]:SetPoint("CENTER", r[i], "CENTER", 0, -1)
		-- b[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-SingleRune.blp")
	end
end

function ria:clear()
	for i=1,CURRENT_MAX_RUNES do
		r[i]:ClearAllPoints()
	end
end

function ria:alpha(val)
	for i=1,CURRENT_MAX_RUNES do
		r[i]:SetAlpha(val)
	end
end

function ria:showRunes()
	for i=1,CURRENT_MAX_RUNES do
		r[i]:Show()
	end
end

function ria:hideRunes()
	for i=1,CURRENT_MAX_RUNES do
		r[i]:Hide()
	end
end

function ria:scale(val)
	for i=1,CURRENT_MAX_RUNES do
		r[i]:SetScale(val)
	end
end

function ria:init()
	CreateRuneButtonIndividualFrames()

	RuneFrame:UnregisterAllEvents()
	RuneFrame:SetAlpha(0)
	RuneFrame:EnableMouse(false)
	RuneFrame:Hide()

	for i = 1,MAX_RUNE_CAPACITY do
		cdText[i] = CreateFrame("Frame")

		r[i]:SetClampedToScreen(true)
		r[i]:SetFrameStrata("LOW")
		r[i]:EnableMouse(false)
		r[i]:Show()
		t[i]:Show()

		local old = _G["RuneButtonIndividual"..i]
		old:Hide()
		old:EnableMouse(false)
		old:SetAlpha(0)
		old:UnregisterAllEvents()

		cdText[i].Text = cdText[i]:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
		cdText[i].Text:SetPoint("CENTER", r[i])
		cdText[i].Text:SetAlpha(1)
		cdText[i].Text:Show()

		cdText[i].lastUpdate = 0
	end

	self:RegisterEvent("RUNE_POWER_UPDATE")
	self:RegisterEvent("RUNE_TYPE_UPDATE")
	self:RegisterUnitEvent("UNIT_MAXPOWER", "player")
	self:RegisterUnitEvent("UNIT_EXITED_VEHICLE", "player")
	self:RegisterUnitEvent("UNIT_ENTERED_VEHICLE", "player")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:SetScript("OnEvent", function(self, event, ...)
		events[event](self, ...)
	end)
end

function events:COMBAT_LOG_EVENT_UNFILTERED(...)
	local type = select(2, ...)
	if (type == "UNIT_DIED") then
			local unit = select(4, ...)
			if (unit == UnitName("player")) then
					self:images(riaDb.textureChoice)
			end
	end
end

function events:UNIT_EXITED_VEHICLE()
	self:refresh()
end

function events:UNIT_ENTERED_VEHICLE()
	if riaDb.entv == "0" then
		self:hideRunes()
	elseif riaDb.entv == "1" then
		self:refresh()
	else
		self:refresh(riaDb.alphaInCombat)
	end
	self:clear()
	self:orientation(riaDb.layoutChoice)
	self:scale(riaDb.scale)
end

function events:RUNE_POWER_UPDATE(...)
	local runeIndex, _ = ...
	self:RunePowerUpdate(runeIndex)
end

function events:RUNE_TYPE_UPDATE(...)
end

function events:UNIT_MAXPOWER()
	self:UpdateRuneCount()
end

function events:PLAYER_ENTERING_WORLD()
	self:UpdateRuneCount()
	-- for i=1, CURRENT_MAX_RUNES do
	-- 	self:RunePowerUpdate(i, false)
	-- end
	self:refresh()

	-- TODO : fix cooldown text
	-- TODO : any local functions?
end

function events:PLAYER_REGEN_DISABLED(...)
	if not UnitInVehicle("player") then
		self:alpha(riaDb.alphaInCombat)
	end
end

function events:PLAYER_REGEN_ENABLED(...)
	if not UnitInVehicle("player") then
		self:alpha(riaDb.alphaOutOfCombat)
	end
end

function ria:refresh(alphaVal)
	alphaVal = alphaVal or riaDb.alphaOutOfCombat

	self:clear()
	self:showRunes()
	self:alpha(alphaVal)
	self:scale(riaDb.scale)
	self:orientation(riaDb.layoutChoice)
	self:images(riaDb.textureChoice)
	self:setV(riaDb.vPadding)
	self:setH(riaDb.hPadding)
end

function ria.updateCdText(self, runeIndex, start, duration, runeReady)
	local apply, time = ria.getCurrentCd(self, start, duration, runeReady)
	if apply then
		ria.setCdText(self, runeIndex, time)
	end
	if runeReady then
		self:SetScript("OnUpdate", nil)
	end
end

function ria.setCdText(self, runeIndex, time)
	self.lastUpdate = GetTime()
	local time = floor(time + 0.5)
	local color = {1, 1, 0}

	if (time == 0) then
		time = ""
	elseif (riaDb.cdTextColor == "RUNE_COLORS") then
		color = runeColors[riaDb.runeType]
	elseif (riaDb.cdTextColor == "CUSTOM_COLOR") then
		color = {
			riaDb.cdCustomColorPicker.r,
			riaDb.cdCustomColorPicker.g,
			riaDb.cdCustomColorPicker.b,
			riaDb.cdCustomColorPicker.opacity
		}
	elseif time < 3 then
		local _, g, _ = self.Text:GetTextColor()
		if (g > 0.5) then color = {1, 0, 0} end
	end
	self.Text:Show()
	self.Text:SetTextColor(unpack(color))
	self.Text:SetText(time)
end

function ria.getCurrentCd(self, start, duration, runeReady)
	local now = GetTime()
	local FREQ = 0.25
	if (runeReady or (now - start) >= duration) then
		return true, 0
	elseif (now >= self.lastUpdate + FREQ) then
		return true, duration - (now - start)
	end
	return false, nil
end

function ria.setCdFontSize(newValue)
	riaDb.cdTextFontSize = newValue

	for i=1,MAX_RUNE_CAPACITY do
		cdText[i].Text:SetFont("Fonts\\FRIZQT__.TTF", newValue)
	end
end

function ria:RunePowerUpdate(runeIndex)
	if runeIndex and runeIndex >= 1 and runeIndex <= CURRENT_MAX_RUNES then
		local start, duration, runeReady = GetRuneCooldown(runeIndex)

		if not runeReady then -- not usable
			if riaDb.cdEnabled == "1" then
				cdText[runeIndex]:SetScript("OnUpdate", function(self) ria.updateCdText(self, runeIndex, start, duration, runeReady) end)
			end
			if riaDb.textureChoice == "BLIZZARD" or riaDb.textureChoice == "NEW_BLIZZARD" then
				b[runeIndex]:SetAlpha(0.3)
			end
			if riaDb.textureChoice == "RUNICA" then
				t[runeIndex]:SetVertexColor(0.3,0.3,0.3,0.9)
			else
				t[runeIndex]:SetVertexColor(0.4,0.4,0.4,riaDb.cdTextAlpha)
			end
			-- if InCombatLockdown() == nil then
			-- 	self:alpha(riaDb.alphaInCombat)
			-- end
		else -- usable
			cdText[runeIndex]:Hide()
			if (riaDb.textureChoice == "BLIZZARD" or riaDb.textureChoice == "NEW_BLIZZARD" or riaDb.textureChoice == "RUNICA") then
				b[runeIndex]:SetAlpha(1)
			end
			t[runeIndex]:SetVertexColor(1,1,1,1)
			if InCombatLockdown() == nil then
				self:alpha(riaDb.alphaOutOfCombat)
			end
		end
	end
end

function ria:UpdateRuneCount()
	CURRENT_MAX_RUNES = UnitPowerMax("player", SPELL_POWER_RUNES)
	for i=1, MAX_RUNE_CAPACITY do
		if(i <= CURRENT_MAX_RUNES) then
			r[i]:Show()
		else
			r[i]:Hide()
		end
	end
end

function ria:lock(unlocked)
	self:clear()
	if unlocked then
		if riaDb.unlockType == "SHAPE" then
			t[1]:SetVertexColor(1,0,0,1)
			r[1]:SetFrameStrata("HIGH")
			r[1]:EnableMouse(true)
			r[1]:SetMovable(true)
			r[1]:RegisterForDrag("LeftButton")
			self:orientation(riaDb.layoutChoice)
			r[1]:SetScript("OnDragStart", function() r[1]:StartMoving() end)
			r[1]:SetScript("OnDragStop", function() r[1]:StopMovingOrSizing()
			riaDb.x, riaDb.y = r[1]:GetLeft(), r[1]:GetBottom() end)
		elseif riaDb.unlockType == "INDIVIDUAL" then
			for i = 1,CURRENT_MAX_RUNES do
				t[i]:SetVertexColor(1,0,0,1)
				r[i]:SetFrameStrata("HIGH")
				r[i]:EnableMouse(true)
				r[i]:SetMovable(true)
				r[i]:RegisterForDrag("LeftButton")
				r[i]:SetScript("OnDragStart", function() r[i]:StartMoving() end)
				r[i]:SetScript("OnDragStop", function() r[i]:StopMovingOrSizing()
				riaDb.ind_x[i], riaDb.ind_y[i] = r[i]:GetLeft(), r[i]:GetBottom() end)
			end
		end
	else
		if riaDb.unlockType == "SHAPE" then
			t[1]:SetVertexColor(1,1,1,1)
			r[1]:SetFrameStrata("LOW")
			r[1]:EnableMouse(false)
			r[1]:SetMovable(false)
		elseif riaDb.unlockType == "INDIVIDUAL" then
			for i = 1,CURRENT_MAX_RUNES do
				t[i]:SetVertexColor(1,1,1,1)
				r[i]:SetFrameStrata("LOW")
				r[i]:EnableMouse(false)
				r[i]:SetMovable(false)
			end
		end
	end
end

function ria:setH(newValue)
	if riaDb.unlockType == "SHAPE" and (riaDb.layoutChoice == "HORIZONTAL") or (riaDb.layoutChoice == "VERTICAL") then
		-- self:clear()
		-- self:orientation(riaDb.layoutChoice)
		for i = 2,CURRENT_MAX_RUNES do
			r[i]:SetPoint("LEFT", r[i-1], "RIGHT", tonumber(newValue), 0)
		end
	end
end

function ria:setV(newValue)
	if riaDb.unlockType == "SHAPE" and (riaDb.layoutChoice == "HORIZONTAL") or (riaDb.layoutChoice == "VERTICAL") then
		-- self:clear()
		-- self:orientation(riaDb.layoutChoice)
		for i = 2,CURRENT_MAX_RUNES do
			r[i]:SetPoint("TOP", r[i-1], "BOTTOM", 0, -tonumber(newValue))
		end
	end
end

function ria:orientation(newValue)
	if riaDb.unlockType == "SHAPE" then
		self:clear()
		if newValue == "VERTICAL" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("BOTTOM", r[1], "TOP", 0, -42)
			r[3]:SetPoint("BOTTOM", r[2], "TOP", 0, -42)
			r[4]:SetPoint("BOTTOM", r[3], "TOP", 0, -42)
			r[5]:SetPoint("BOTTOM", r[4], "TOP", 0, -42)
			r[6]:SetPoint("BOTTOM", r[5], "TOP", 0, -42)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("BOTTOM", r[6], "TOP", 0, -42)
			end
		elseif newValue == "HORIZONTAL" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("LEFT", r[1], "RIGHT", 4, 0)
			r[3]:SetPoint("LEFT", r[2], "RIGHT", 4, 0)
			r[4]:SetPoint("LEFT", r[3], "RIGHT", 4, 0)
			r[5]:SetPoint("LEFT", r[4], "RIGHT", 4, 0)
			r[6]:SetPoint("LEFT", r[5], "RIGHT", 4, 0)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("LEFT", r[6], "RIGHT", 4, 0)
			end
		elseif newValue == "VERTICAL_BLOCK" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("LEFT", r[1], "RIGHT", 4, 0)
			r[3]:SetPoint("BOTTOM", r[1], "BOTTOM", 0, -22)
			r[4]:SetPoint("BOTTOM", r[2], "BOTTOM", 0, -22)
			r[5]:SetPoint("BOTTOM", r[3], "BOTTOM", 0, -22)
			r[6]:SetPoint("BOTTOM", r[4], "BOTTOM", 0, -22)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("BOTTOM", r[5], "BOTTOM", 0, -22)
			end
		elseif newValue == "UP_CURVE" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("LEFT", r[1], "RIGHT", 6, 26)
			r[3]:SetPoint("LEFT", r[1], "RIGHT", 40, 36)
			r[4]:SetPoint("LEFT", r[3], "RIGHT", 12, 0)
			r[5]:SetPoint("LEFT", r[1], "RIGHT", 102, 26)
			r[6]:SetPoint("LEFT", r[1], "RIGHT", 125, 0)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("LEFT", r[1], "RIGHT", 150, 26)
				-- CLEAN THIS UP
			end
		elseif newValue == "HORIZONTAL_BLOCK" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("BOTTOM", r[1], "BOTTOM", 0, -22)
			r[3]:SetPoint("LEFT", r[1], "RIGHT", 4, 0)
			r[4]:SetPoint("LEFT", r[2], "RIGHT", 4, 0)
			r[5]:SetPoint("LEFT", r[3], "RIGHT", 4, 0)
			r[6]:SetPoint("LEFT", r[4], "RIGHT", 4, 0)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("LEFT", r[5], "RIGHT", 4, 0)
			end
		elseif newValue == "DOWN_CURVE" then
			r[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.x, riaDb.y)
			r[2]:SetPoint("LEFT", r[1], "RIGHT", 6, -26)
			r[3]:SetPoint("LEFT", r[1], "RIGHT", 40, -36)
			r[4]:SetPoint("LEFT", r[3], "RIGHT", 12, 0)
			r[5]:SetPoint("LEFT", r[1], "RIGHT", 102, -26)
			r[6]:SetPoint("LEFT", r[1], "RIGHT", 125, 0)
			if CURRENT_MAX_RUNES > 6 then
				r[7]:SetPoint("LEFT", r[1], "RIGHT", 150, 26)
				-- CLEAN THIS UP
			end
		end
	else
		for i = 1, CURRENT_MAX_RUNES do
			r[i]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", riaDb.ind_x[i], riaDb.ind_y[i])
		end
	end
end

function ria:images(newValue)
    if newValue == "BETA" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "BLIZZARD" then
        hide = false
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            -- cooldown[i]:Show()
            if runica == true then
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
                -- cooldown[i]:SetWidth(18)
                -- cooldown[i]:SetHeight(18)
                o[i]:SetTexture(nil)
            end
        end
		elseif newValue == "NEW_BLIZZARD" then
			hide = false
			for i = 1, CURRENT_MAX_RUNES do
					b[i]:Show()
					b[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-SingleRune.blp")
					if runica == true then
							t[i]:SetTexCoord(0,1,0,1)
							r[i]:SetHeight(18)
							r[i]:SetWidth(18)
							o[i]:SetTexture(nil)
					end
			end
			RuneItAllControlPanelruneTypeButton:SetText("Death")
			riaDb.runeType = "DEATH"
    elseif newValue == "DKI" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "LETTER" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "ORB" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "ENHANCED" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "JAPENESE" then
        hide = true
        for i = 1, CURRENT_MAX_RUNES do
            b[i]:Hide()
            if runica == true then
                o[i]:SetTexture(nil)
                t[i]:SetTexCoord(0,1,0,1)
                r[i]:SetHeight(18)
                r[i]:SetWidth(18)
            end
        end
    elseif newValue == "RUNICA" then
        hide = false
        runica = true
        for i = 1, CURRENT_MAX_RUNES do
            t[i]:SetTexCoord(0.1,0.9,0.1,0.9)
            b[i]:Hide()
            r[i]:SetHeight(21)
            r[i]:SetWidth(21)
            -- cooldown[i]:Show()
            -- cooldown[i]:SetWidth(22)
            -- cooldown[i]:SetHeight(22)
            o[i] = r[i]:CreateTexture("RBI"..i.."Overlay", "OVERLAY")
            o[i]:SetTexture(path.."runica\\border.tga")
            o[i]:SetAllPoints(t[i])
        end
				self:orientation(riaDb.layoutChoice)
    end
		for i=1,CURRENT_MAX_RUNES do
			t[i]:SetTexture(iconTextures[riaDb.runeType][newValue])
		end
end

SlashCmdList["RUNEITALL"] = function(msg)
	RuneItAll_SlashHandler(string.lower(msg))
end

SLASH_RUNEITALL1 = "/runeitall"
SLASH_RUNEITALL2 = "/ria"
SLASH_RUNEITALL3 = "/rune-it-all"

function RuneItAll_SlashHandler(msg)
    local frame = LibStub("Portfolio").GetOptionsFrame("RuneItAll")
    InterfaceOptionsFrame_OpenToCategory(frame)
end

ria:init()
